FlightApp/FlightApp.Web/Models/ErrorViewModel.cs
namespace FlightApp.Web.Models
{
    public class ErrorViewModel
    {
        public string ErrorMessage { get; set; }
    }

}

FlightApp/FlightApp.Web/Models/FlightListViewModel.cs
using FlightApp.Core.Models;
using System.ComponentModel.DataAnnotations;

namespace FlightApp.Web.Models
{

    public class FlightListViewModel
    {
        public int Id { get; set; }
        public string Name { get; set; }
        public string DepartureAirportName { get; set; }
        public string ArrivalAirportName { get; set; }
        public double Distance { get; set; }
    }

}

FlightApp/FlightApp.Web/Models/FlightViewModel.cs
using FlightApp.Core.Models;
using System.ComponentModel.DataAnnotations;

namespace FlightApp.Web.Models
{
    public class FlightViewModel
    {
        public int Id { get; set; }
        [Required(ErrorMessage = "Please enter the flight name.")]
        [Display(Name = "Flight Name")]
        public string Name { get; set; }
        [Display(Name = "Departure Airport")]
        public int DepartureAirportId { get; set; }
        [Display(Name = "Arrival Airport")]
        public int ArrivalAirportId { get; set; }
        public List<Airport> AvailableAirports { get; set; } = new List<Airport>();
    }
}

FlightApp/FlightApp.Web/Controllers/FlightController.cs
using FlightApp.Core.Interfaces;
using FlightApp.Core.Models;
using FlightApp.Web.Models;
using Microsoft.AspNetCore.Mvc;

namespace FlightApp.Web.Controllers
{
    public class FlightController : Controller
    {
        private readonly IFlightService _flightService;
        private readonly IAirportService _airportService;
        private readonly ILogger<FlightController> _logger;

        public FlightController(IFlightService flightService, IAirportService airportService,ILogger<FlightController> logger)
        {
            _flightService = flightService;
            _airportService = airportService;
            _logger = logger;
        }
        public IActionResult Index()
        {
            try
            {
                var flights = _flightService.GetAllFlights();
                var flightViewModels = flights.Select(flight => new FlightListViewModel
                {
                    Id = flight.Id,
                    Name = flight.Name,
                    DepartureAirportName = flight.DepartureAirport.Name,
                    ArrivalAirportName = flight.ArrivalAirport.Name,
                    Distance = flight.CalculateDistance()
                }).ToList();

                return View(flightViewModels);
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, "An error occurred while retrieving flight data.");
                return View("Error", new ErrorViewModel { ErrorMessage = "An error occurred while retrieving flight data." }); 
                
            }
        }

        public IActionResult Create()
        {
            var viewModel = new FlightViewModel
            {
                AvailableAirports = (List<Airport>)_airportService.GetAllAirports(),
            };

            return View(viewModel);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult Create(FlightViewModel flightViewModel)
        {
            try
            {

                if (ModelState.IsValid)
                {
                    var flight = new Flight
                    {
                        Name = flightViewModel.Name,
                        DepartureAirportId = flightViewModel.DepartureAirportId,
                        ArrivalAirportId = flightViewModel.ArrivalAirportId,
                    };

                    _flightService.AddFlight(flight);

                    return RedirectToAction("Index");
                }

                flightViewModel.AvailableAirports = (List<Airport>)_airportService.GetAllAirports();

                return View(flightViewModel);
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, "An error occurred while creating a flight.");
                return View("Error", new ErrorViewModel { ErrorMessage = "An error occurred while creating a flight." });
            }
            
        }

        public IActionResult Edit(int id)
        {
            try
            {

                var flight = _flightService.GetFlightById(id);
                if (flight == null)
                {
                    return NotFound();
                }
                var viewModel = new FlightViewModel
                {
                    Id = flight.Id,
                    Name = flight.Name,
                    DepartureAirportId = flight.DepartureAirportId,
                    ArrivalAirportId = flight.ArrivalAirportId,
                    AvailableAirports = (List<Airport>)_airportService.GetAllAirports(),
                };


                return View(viewModel);
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, "An error occurred while retrieving flight data for editing.");
                return View("Error", new ErrorViewModel { ErrorMessage = "An error occurred while retrieving flight data for editing." });

            }
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult Edit(FlightViewModel viewModel)
        {
            try
            {
                if (ModelState.IsValid)
                {
                    try
                    {
                        var flight = _flightService.GetFlightById(viewModel.Id);
                        flight.Name = viewModel.Name;
                        flight.ArrivalAirportId = viewModel.ArrivalAirportId;
                        flight.DepartureAirportId = viewModel.DepartureAirportId;
                        _flightService.UpdateFlight(flight);
                    }
                    catch
                    {
                        return NotFound();
                    }
                    return RedirectToAction("Index");
                }

                viewModel.AvailableAirports = (List<Airport>)_airportService.GetAllAirports();
                return View(viewModel);
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, "An error occurred while updating the flight.");
                return View("Error", new ErrorViewModel { ErrorMessage = "An error occurred while updating the flight." });
            }
        }

        public IActionResult Delete(int id)
        {
            try
            {
                var flight = _flightService.GetFlightById(id);
            
                if (flight == null)
                {
                    return NotFound();
                }
                return View(flight);
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, "An error occurred while retrieving flight data for deletion.");
                return View("Error", new ErrorViewModel { ErrorMessage = "An error occurred while retrieving flight data for deletion." });
            }
        }

        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public IActionResult DeleteConfirmed(int id)
        {
            try
            {
                _flightService.DeleteFlight(id);
                return RedirectToAction("Index");

            }
            catch (Exception ex)
            {
                _logger.LogError(ex, "An error occurred while deleting flight data.");
                return View("Error", new ErrorViewModel { ErrorMessage = "An error occurred while deleting flight data." });
            }
        }
    }
}

FlightApp/FlightApp.Web/Views/Flight/Create.cshtml
@using FlightApp.Web.Models;
@model FlightViewModel
@{
    ViewBag.Title = "Create Flight";
}

<div class="container">
    <div class="row justify-content-center mt-5">
        <div class="col-md-6">
            <div class="card">
                <div class="card-header d-flex justify-content-between align-items-center">
                    <h2 class="card-title">New Flight</h2>
                    <a asp-action="Index" class="btn-close"></a>
                </div>
                <div class="card-body">
                    @using (Html.BeginForm("Create", "Flight", FormMethod.Post, new { @class = "form" }))
                    {
                        @Html.AntiForgeryToken()

                        <div class="form-group mb-3">
                            @Html.LabelFor(model => model.Name, new { @class = "control-label" })
                            @Html.TextBoxFor(model => model.Name, new { @class = "form-control" })
                            @Html.ValidationMessageFor(model => model.Name, "", new { @class = "text-danger" })
                        </div>

                        <div class="form-group mb-3">
                            @Html.LabelFor(model => model.DepartureAirportId, new { @class = "control-label" })
                            @Html.DropDownListFor(model => model.DepartureAirportId, new SelectList(Model.AvailableAirports, "Id", "Name"), "Select Departure Airport", new { @class = "form-control", id = "departureAirportId" })
                            @Html.ValidationMessageFor(model => model.DepartureAirportId, "", new { @class = "text-danger" })
                        </div>

                        <div class="form-group mb-3">
                            @Html.LabelFor(model => model.ArrivalAirportId, new { @class = "control-label" })
                            @Html.DropDownListFor(model => model.ArrivalAirportId, new SelectList(Model.AvailableAirports, "Id", "Name"), "Select Arrival Airport", new { @class = "form-control", id = "arrivalAirportId" })
                            @Html.ValidationMessageFor(model => model.ArrivalAirportId, "", new { @class = "text-danger" })
                        </div>

                        <button type="submit" class="btn btn-primary btn-block mt-2 w-100">Create</button>
                    }
                </div>
            </div>
        </div>
    </div>
</div>

<script>
    $(document).ready(function () {
        $("#departureAirportId").change(function () {
            var selectedDepartureAirport = $(this).val();
            $("#arrivalAirportId option").prop("disabled", false);
            $("#arrivalAirportId option[value='" + selectedDepartureAirport + "']").prop("disabled", true);
        });

        $("#arrivalAirportId").change(function () {
            var selectedArrivalAirport = $(this).val();
            $("#departureAirportId option").prop("disabled", false);
            $("#departureAirportId option[value='" + selectedArrivalAirport + "']").prop("disabled", true);
        });
    });
</script>

FlightApp/FlightApp.Web/Views/Flight/Delete.cshtml
@using FlightApp.Core.Models;
@model Flight

@{
    ViewBag.Title = "Delete Flight";
}

<div class="container mt-5 d-flex justify-content-center align-items-center">
    <div class="card">
        <h2 class="card-header">Delete Flight</h2>
        <div class="card-body">
            <p>Are you sure you want to delete this flight?</p>

            <dl class="dl-horizontal">
                <dt>@Html.DisplayNameFor(model => model.Name)</dt>
                <dd>@Html.DisplayFor(model => model.Name)</dd>
            </dl>

            @using (Html.BeginForm("DeleteConfirmed"))
            {
                @Html.AntiForgeryToken()
                <div class="form-group">
                    <a href="@Url.Action("Index")" class="btn btn-secondary">Back to List</a>
                    <button type="submit" class="btn btn-danger">Delete</button>
                </div>
            }
        </div>
    </div>
</div>

FlightApp/FlightApp.Web/Views/Flight/Edit.cshtml
@using FlightApp.Web.Models;
@model FlightViewModel

@{
    ViewBag.Title = "Edit Flight";
}

<div class="container">
    <div class="row justify-content-center align-items-center mt-5">
        <div class="col-md-6">
            <div class="card">
                <div class="card-header  text-center">
                    <h2 class="card-title">Edit Flight</h2>
                </div>
                <div class="card-body">
                    @using (Html.BeginForm())
                    {
                        @Html.AntiForgeryToken()
                        @Html.HiddenFor(model => model.Id)

                        <div class="form-group mb-3">
                            @Html.LabelFor(model => model.Name)
                            @Html.TextBoxFor(model => model.Name, new { @class = "form-control" })
                            @Html.ValidationMessageFor(model => model.Name, "", new { @class = "text-danger" })
                        </div>

                        <div class="form-group mb-3">
                            @Html.LabelFor(model => model.DepartureAirportId)
                            @Html.DropDownListFor(model => model.DepartureAirportId, new SelectList(Model.AvailableAirports, "Id", "Name"), "Select Departure Airport", new { @class = "form-control", id = "departureAirportId" })
                            @Html.ValidationMessageFor(model => model.DepartureAirportId, "", new { @class = "text-danger" })
                        </div>

                        <div class="form-group mb-3">
                            @Html.LabelFor(model => model.ArrivalAirportId)
                            @Html.DropDownListFor(model => model.ArrivalAirportId, new SelectList(Model.AvailableAirports, "Id", "Name"), "Select Arrival Airport", new { @class = "form-control", id = "arrivalAirportId" })
                            @Html.ValidationMessageFor(model => model.ArrivalAirportId, "", new { @class = "text-danger" })
                        </div>

                        <div class="d-flex justify-content-evenly">
                            <a href="@Url.Action("Index")" class="btn btn-secondary">Back to List</a>
                            <button type="submit" class="btn btn-primary">Save Changes</button>
                        </div>
                    }
                </div>
            </div>
        </div>
    </div>
</div>

<script>
    $(document).ready(function () {
        function disableConflictingOptions() {
            var selectedDepartureAirport = $("#departureAirportId").val();
            var selectedArrivalAirport = $("#arrivalAirportId").val();

            $("#arrivalAirportId option").prop("disabled", false);
            $("#departureAirportId option").prop("disabled", false);
            $("#arrivalAirportId option[value='" + selectedDepartureAirport + "']").prop("disabled", true);
            $("#departureAirportId option[value='" + selectedArrivalAirport + "']").prop("disabled", true);
        }

        disableConflictingOptions();

        $("#departureAirportId").change(disableConflictingOptions);
        $("#arrivalAirportId").change(disableConflictingOptions);
    });
</script>

FlightApp/FlightApp.Web/Views/Flight/Index.cshtml
@using FlightApp.Web.Models
@model IEnumerable<FlightListViewModel>

<div class="container">
    <h2>Flight List</h2>
    <div class="d-flex justify-content-end mb-3">
        <a asp-controller="Flight" asp-action="Create" class="btn btn-success">Create New Flight</a>
    </div>

    @if (!Model.Any())
    {
        <p>No flights available.</p>
    }
    else
    {
        <table class="table table-dark table-hover table-striped">
            <thead>
                <tr>
                    <th>Name</th>
                    <th>Departure Airport</th>
                    <th>Arrival Airport</th>
                    <th>Distance (kilometers)</th>
                    <th>Actions</th>
                </tr>
            </thead>
            <tbody>
                @foreach (var flight in Model)
                {
                    <tr>
                        <td>@flight.Name</td>
                        <td>@flight.DepartureAirportName</td>
                        <td>@flight.ArrivalAirportName</td>
                        <td>@flight.Distance</td>
                        <td>
                            <a asp-controller="Flight" asp-action="Edit" asp-route-id="@flight.Id" class="btn btn-primary btn-sm">Edit</a>
                            <a asp-controller="Flight" asp-action="Delete" asp-route-id="@flight.Id" class="btn btn-danger btn-sm">Delete</a>
                        </td>
                    </tr>
                }
            </tbody>
        </table>
    }
</div>

FlightApp/FlightApp.Web/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html>
<head>
    <title>Flight App</title>
    <link href="~/lib/twitter-bootstrap/css/bootstrap.css" rel="stylesheet" />
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
</head>
<body>
    <div class="container">
        @RenderBody()
    </div>
</body>
</html>